import { ILayer, ILayerPlugin } from '@antv/l7-core';
import 'reflect-metadata';
/**
 * 在渲染之前需要获取当前 Shader 所需 Uniform，例如：
 * 1. 从相机服务中获取 View & ProjectionMatrix，当前缩放等级等等
 * 2. 从坐标系服务中获取当前坐标系，例如是否是偏移坐标系
 *    @see https://yuque.antfin-inc.com/yuqi.pyq/fgetpa/doml91
 * 3. 当前 Layer 本身的样式属性
 */
export default class ShaderUniformPlugin implements ILayerPlugin {
    private readonly cameraService;
    private readonly coordinateSystemService;
    private readonly rendererService;
    private readonly mapService;
    apply(layer: ILayer): void;
}
